   Imports System.Text
   Imports System.Security.Cryptography
   
   Public Module MyCryptoLib
   
   ...

   Public Sub EncryptFile( _
                ByVal File1 As String, _
                ByVal File2 As String, _
                ByVal Password As String _
              )

     ' Utworzenie instancji CSP
     Dim des As New DESCryptoServiceProvider()

     ' Utworzenie tablic przechowujcych klucz i IV tego szyfru
     Dim key() As Byte
     Dim iv() As Byte

     ' Utworzenie odpowiednigo klucza i IV dla szyfru DES
     GenerateKey(Password, des.BlockSize, key, iv)
     des.Key = key
     des.IV = iv

     ' Utworzenie strumieni plikowych dla wejcia i wyjcia
     Dim filIn As New FileStream(File1, FileMode.Open , FileAccess.Read)
     Dim filOut As New FileStream(File2, FileMode.OpenOrCreate, FileAccess.Write)

     ' Utworzenie strumienia szyfrujcego
     Dim encStream As New CryptoStream(filOut, des.CreateEncryptor(), CryptoStreamMode.Write)

     ' Utworzenie pojemnika do przechowywania blokw szyfru
     Dim data(4096) As Byte

     ' Zmienne przechowujce informacje o pooeniu w FileStream
     Dim len As Integer
     Dim readLen As Integer
     Dim fileLen As Integer = filIn.Length

     Do While readLen < fileLen
       ' Pobranie bloku i jego rozmiaru
       len = filIn.Read(data, 0, 4096)
       
       ' Zapisanie bloku do szyfrowania
       encStream.Write(data, 0, len)

       ' Zwikszenie liczby oznaczajcej ilo wczytanych znakw
       readLen += len
     Loop

     ' Zamknicie strumieni, "wypukanie" zawartoci bufora i zapisanie pliku
     encStream.Close()
     filIn.Close()
     filOut.Close()

   End Sub

   Public Sub DecryptFile( _
                     ByVal File1 As String, _
                     ByVal File2 As String, _
                     ByVal Password As String _
                   )

     ' Utworzenie instancji CSP
     Dim des As New DESCryptoServiceProvider()
     
     ' Utworzenie tablic przechowujcych klucz i IV tego szyfru
     Dim key() As Byte
     Dim iv() As Byte

     ' Utworzenie odpowiednigo klucza i IV dla szyfru DES
     GenerateKey(Password, des.BlockSize, key, iv)
     des.Key = key
     des.IV = iv

     ' Utworzenie strumieni plikowych dla wejcia i wyjcia
     Dim filIn As New FileStream(File1, FileMode.Open , FileAccess.Read)
     Dim filOut As New FileStream(File2, FileMode.OpenOrCreate, FileAccess.Write)

     ' Utworzenie strumienia deszyfrujcego
     Dim decStream As New CryptoStream(filOut, des.CreateDecryptor(), CryptoStreamMode.Write)

     ' Utworzenie pojemnika do przechowywania blokw szyfru
     Dim data(4096) As Byte

     ' Zmienne przechowujce informacje o pooeniu w FileStream
     Dim len As Integer
     Dim readLen As Integer
     Dim fileLen As Integer = filIn.Length

     Do While readLen < fileLen
       ' Pobranie bloku i jego rozmiaru
       len = filIn.Read(data, 0, 4096)

       ' Zapisanie bloku do deszyfrowania
       decStream.Write(data, 0, len)

       ' increment size of read characters
       readLen += len
     Loop

     ' Zamknicie strumieni, "wypukanie" zawartoci bufora i zapisanie pliku
     decStream.Close()
     filIn.Close()
     filOut.Close()

   End Sub

 End Module